Subject: Re: [PATCH ath-next] wifi: ath12k: avoid setting 320MHZ support on non 6GHz band

From: "Nicolas Escande" <[email-masked]>
Date: Mon, 26 Jan 2026 11:11:30 +0100

On Fri Jan 23, 2026 at 8:29 PM CET, Johannes Berg wrote:
> On Fri, 2026-01-23 at 20:21 +0100, Pablo MARTIN-GOMEZ wrote:
>> 
>> > > > +	} else {
>> > > > +		phy_cap[0] &= ~IEEE80211_EHT_PHY_CAP0_320MHZ_IN_6GHZ;
>> > > > +		phy_cap[1] &= ~IEEE80211_EHT_PHY_CAP1_BEAMFORMEE_SS_320MHZ_MASK;
>> > > > +		phy_cap[2] &= ~IEEE80211_EHT_PHY_CAP2_SOUNDING_DIM_320MHZ_MASK;
>> > > > +		phy_cap[6] &= ~IEEE80211_EHT_PHY_CAP6_MCS15_SUPP_320MHZ;
>> > > > +	}
>> > > If you want to clear all 320 MHz fields, you'll also have to clear
>> > > IEEE80211_EHT_PHY_CAP7_NON_OFDMA_UL_MU_MIMO_320MHZ and
>> > > IEEE80211_EHT_PHY_CAP7_MU_BEAMFORMER_320MHZ (not sure why it is not done
>> > > in mac80211)
>> > > 

If the QCA guys are interrested I can post a v2 with the additionnal bits also
cleared.

>> > This is, effectively, a firmware workaround. It doesn't belong into
>> > mac80211. All other drivers just have their capabilities managed in the
>> > driver anyway.
>> > 
>> > johannes
>> 

Yep you made me realize that. So I tracked how to fix it in the underlying
driver and posted this patch.

>> I wasn't talking about putting this patch in mac80211 (I've seen the 
>> discussion on the patch Nicolas sent on linux-wireless), I'm talking 
>> about the function `ieee80211_put_eht_cap` clearing the Beamformee SS 
>> and Sounding Dimension fields but not the Non-OFDMA UL MU-MIMO and MU 
>> Beamformer fields for each bandwidth.
>
> Ah, you're asking why mac80211 doesn't clear those bits ... I guess it
> just doesn't matter. If you're not on 320 MHz I'd guess the bits are
> never checked, so it's not really relevant at all, although then could
> argue that you only need the first line here as well.

I you want Johannes, I can post a patch that also clears those bits in mac80211
> johannes

Nico,